#pragma once
#ifndef LRTABLES_LR0ITEMSET_H_HTSWOGFB
#define LRTABLES_LR0ITEMSET_H_HTSWOGFB

#include "Parsodus/lrtables/generator.h"
#include "Parsodus/lrtables/LR0Item.h"

#include <memory>

namespace pds {
namespace lr {
    
/**
 * An LR(0) itemset, @see Generator for details on the public methods
 */
class LR0Itemset {
public:
    LR0Itemset();
    LR0Itemset(std::shared_ptr<Rule> start);

    void close(const Grammar& g);
    LR0Itemset succ(std::string sym) const;
    bool operator==(const LR0Itemset& rhs) const;
    bool canMerge(const LR0Itemset& rhs) const;
    void merge(const LR0Itemset& rhs);
    bool empty() const;
    std::set<std::size_t> getReduces(const Grammar& g, std::string lookahead) const;

    void print() const; ///TODO remove me

private:
    std::set<LR0Item> m_items;

};

} /* lr */ 
} /* pds */

#endif /* LRTABLES_LR0ITEMSET_H_HTSWOGFB */
